2018-05-25 10:07 BST

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0002824OpenFOAM[All Projects] Bugpublic2018-02-07 15:39
Reporterarohner 
Assigned Tohenry 
PriorityhighSeveritymajorReproducibilityalways
StatusresolvedResolutionfixed 
PlatformUnixOSWindows Sub (Ubuntu)OS Version16.04.3 LTS
Product Version5.0 
Target VersionFixed in Versiondev 
Summary0002824: violation of mass conservation in compressibleInterDyMFoam
DescriptionComparing a simple case, where the system is closed with just a piston compressing the gas inside, shows wrong behavior in pressure and density. They both do not rise as expected due to mass loss in the system. With rhoPimpleDyMFoam I do get the correct behavior.
Steps To ReproduceRunning the attached case, which has been adapted from a previous issue (https://bugs.openfoam.org/view.php?id=1110)
on the same topic shows the mentioned behavior. The case has been slightly changed, so that the whole system is closed, hence no inlet/outlet, just a piston compressing the air inside the volume.
Pressure and density do not rise as expected due to mass loss in the system.
TagsNo tags attached.
Attached Files

-Relationships
+Relationships

-Notes

~0009252

henry (manager)

Have you tested OpenFOAM-dev?

~0009253

arohner (reporter)

Hi Henry,

Thanks for the prompt answer. No, I didn't check it with the -dev version. Have there been any recent updates regarding this solver?

~0009254

henry (manager)

Yes there have been changes which might affect this behavior. In anycase all tests and changes will be made to OpenFOAM-dev so it is necessary to first test this version.

> shows wrong behavior in pressure and density.

Could you provide more details? What is wrong about the behavior in pressure and density?

~0009255

arohner (reporter)

When I evaluate the System after runtime I should get a density of around 1.2kg/m3, from which the solution is still far away with around 1.7kg/m3. This is due to mass loss observed by integrating the density. I wrote this issue here because I couldn't find any problems regarding convergence. Pressure seems to converge fine.

~0009256

henry (manager)

I am surprised that mass loss is causing an increase in density, could you clarify?

~0009257

arohner (reporter)

Nono. To clarify. I observe that density as well as pressure does not increase as expected. I mean the setup can be hand calculated using isotropic compression. Reason for this behavior is that mass conservations is violated by losing mass during the process of compressing. I do just not find a reason - at least not by checking the setup and all the solver settings - why there is this mass loss.

~0009258

arohner (reporter)

Oh. the number is 1.17kg/m3.

~0009259

henry (manager)

Note that compressibleInterDyMFoam operates a corrected incompressible algorithms in order to handle the large phase density differences in two-phase sytems. This means that mass conservation is only obtained by converging the PIMPLE loop sufficiently, proved it does converge. Try tightening tolerances and running more PIMPLE iterations to see if this reduces the convervation error.

rhoPimpleDyMFoam runs a mass conservative compressible algorithm which is appropriate for single-phase, and as such converves mass simply by converging the pressure solution irrespective of convergence of the PIMPLE loop.

~0009260

arohner (reporter)

Thanks for the insights. This makes things clearer. Unfortunately I had no success with tightening tolerances nor highering PIMPLE interations.

~0009261

henry (manager)

I have isolated the problem and will investigate further.

~0009275

henry (manager)

Resolved by commit 852726c25fbe6b4bd4e947bec7ff32bc92bb103e
+Notes

-Issue History
Date Modified Username Field Change
2018-02-05 08:33 arohner New Issue
2018-02-05 08:33 arohner File Added: henry_2.0.zip
2018-02-05 08:52 henry Note Added: 0009252
2018-02-05 09:04 arohner Note Added: 0009253
2018-02-05 09:13 henry Note Added: 0009254
2018-02-05 13:04 arohner Note Added: 0009255
2018-02-05 13:37 henry Note Added: 0009256
2018-02-05 13:53 arohner Note Added: 0009257
2018-02-05 13:54 arohner Note Added: 0009258
2018-02-05 14:05 henry Note Added: 0009259
2018-02-05 14:56 arohner Note Added: 0009260
2018-02-05 15:29 henry Note Added: 0009261
2018-02-07 15:39 henry Assigned To => henry
2018-02-07 15:39 henry Status new => resolved
2018-02-07 15:39 henry Resolution open => fixed
2018-02-07 15:39 henry Fixed in Version => dev
2018-02-07 15:39 henry Note Added: 0009275
+Issue History